@ECHO OFF

SETLOCAL

ECHO.
ECHO IBM Business Process Manager 8.0.1 Upgrade
ECHO.

SET SCRIPT_DIR=%~dp0
PUSHD %SCRIPT_DIR%..\..\..\..\..\bin
CALL "setupCmdLine.bat" %*
POPD

IF NOT "%USER_INSTALL_ROOT%"=="" GOTO setupArguments
ECHO .
ECHO Profile does not exist.
ECHO.
SET RC=1
GOTO help

:setupArguments
SET RC=0
SET WAS_HOME_PROP=-Dwas.install.root="%WAS_HOME%"
SET APP_JAVA_POLICY=-Djava.security.policy="file:%SCRIPT_DIR%java.policy"
SET NODE_NAME_PROP=
SET SERVER_NAME_PROP=
SET LOGGING_PROP=-Dcom.lombardisoftware.ant.JULDefaultLogger.level=DEBUG -Djava.util.logging.config.file="%SCRIPT_DIR%logging.properties" -Dtw.log4j.init=false
SET LOGGING_FILTER_PROP=-Dcom.lombardi.logging.StringFilter.excludes=contains(db.password);equals(WSVR0072W);equals(WSVR0801I);equals(WKSP0500);regexp(^Class.+loaded.from.ant.loader..parentFirst.);regexp(^Class.+loaded.from.parent.loader..parentFirst.);regexp(^Finding.class.+\..+\..+);regexp(^Loaded.from.+\.jar..+\.class$)
SET LOGGING_PROP=%LOGGING_PROP% %LOGGING_FILTER_PROP%
SET ANT_PROPS=-q -e -logger com.lombardisoftware.ant.JULDefaultLogger
SET UPGRADECOMMAND_PROP=-Dupgradecommand="%0 %*"

:processArguments
IF "%1" == "-?" GOTO help
IF "%1" == "-help" GOTO help

IF "%1"=="-profileName" (
	IF "%2"== "" (
		GOTO NoValueSpecified
	) ELSE (
		SHIFT&SHIFT&GOTO processArguments
	)
)

IF "%1"=="-serverName" (
	IF "%2"== "" (
		GOTO NoValueSpecified
	) ELSE (
		SET SERVER_NAME_PROP=-DserverName=%2%&SHIFT&SHIFT&GOTO processArguments
	)
)

IF "%1"=="-nodeName" (
	IF "%2"== "" (
		GOTO NoValueSpecified
	) ELSE (
		SET NODE_NAME_PROP=-DnodeName=%2%&SHIFT&SHIFT&GOTO processArguments
	)
)

IF "%1"=="-perfServerName" (
	IF "%2"== "" (
		GOTO NoValueSpecified
	) ELSE (
		SET PERF_SERVER_NAME_PROP=-DperfServerName=%2%&SHIFT&SHIFT&GOTO processArguments
	)
)

IF "%1"=="-perfNodeName" (
	IF "%2"== "" (
		GOTO NoValueSpecified
	) ELSE (
		SET PERF_NODE_NAME_PROP=-DperfNodeName=%2%&SHIFT&SHIFT&GOTO processArguments
	)
)

IF "%1"=="-ifix" (
	SET IFIX_NUMBERS=
:processIFix
	SET TEMP_VARIABLE=%2%
REM need to refresh the varibles to get the value
	GOTO refreshEnvVar
:refreshEnvVar
	IF "%TEMP_VARIABLE%"== "" (
		SET IFIX_TO_INSTALL=-Difix=%IFIX_NUMBERS%&SHIFT&SHIFT&GOTO processArguments
	)
	IF "%TEMP_VARIABLE:~0,1%"== "-" (
		SET IFIX_TO_INSTALL=-Difix=%IFIX_NUMBERS%&SHIFT&GOTO processArguments
	) ELSE (
		SET IFIX_NUMBERS=%IFIX_NUMBERS%%2%,&SHIFT&GOTO processIFix
	)
)

IF "%1"=="-noPrompt" (
	SET NO_PROMPT_PROP=-DnoPrompt=true&SHIFT&GOTO processArguments
)

IF NOT "%1"=="" (
	ECHO Invalid parameter: %1%, please correct it and try again.
	GOTO help
)

SET CLASSPATH=%SCRIPT_DIR%
SET CLASSPATH=%CLASSPATH%;%SCRIPT_DIR%lib\ant.jar
SET CLASSPATH=%CLASSPATH%;%SCRIPT_DIR%lib\ant-launcher.jar
SET CLASSPATH=%CLASSPATH%;%SCRIPT_DIR%lib\ant-nodeps.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%\BPM\Lombardi\lib\ant-contrib.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%\BPM\Lombardi\lib\twant.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%\BPM\Lombardi\lib\langutil.jar


"%JAVA_HOME%\bin\java" -cp "%CLASSPATH%" %WAS_HOME_PROP% %APP_JAVA_POLICY% %USER_INSTALL_PROP% %NODE_NAME_PROP% %SERVER_NAME_PROP% %PERF_NODE_NAME_PROP% %PERF_SERVER_NAME_PROP% %NO_PROMPT_PROP% %LOGGING_PROP% %IFIX_TO_INSTALL% %UPGRADECOMMAND_PROP% org.apache.tools.ant.Main -buildfile "%SCRIPT_DIR%upgrade.xml" %ANT_PROPS%
SET RC=%ERRORLEVEL%
GOTO end

:NoValueSpecified
ECHO No value specified for parameter %1
GOTO help

:help
ECHO.
ECHO Starts or continues the upgrade.
ECHO .
ECHO Usage:
ECHO.
ECHO    upgradeProcessData.bat [options...]
ECHO.
ECHO Options:
ECHO    -?, -help                             This help message
ECHO    -profileName ^<name^>                   Profile name
ECHO    -nodeName ^<name^>                      Node name in ND environment
ECHO    -serverName ^<name^>                    Server name in ND environment
ECHO    -perfNodeName ^<name^>                  Specified node name of Performance Data Warehouse in ND environment (optional)
ECHO    -perfServerName ^<name^>                Specified server name of Performance Data Warehouse in ND environment (optional)
ECHO    -noPrompt                               Set -noPrompt flag to make the tool work with no interaction. If you do not set this parameter, the tool will prompt you to confirm (optional)
ECHO    -ifix ^<ifix list separated by ,^>      Specify '-ifix JRXXXXX,JRYYYYY' to update database for ifix
ECHO .
GOTO end

:end
ECHO.
EXIT /B %RC%
ENDLOCAL
